package de.mdelab.mlsdm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import de.mdelab.mlsdm.diagram.edit.policies.MlsdmBaseItemSemanticEditPolicy;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * @generated
 */
public class MapEntryLinkReorientCommand extends EditElementCommand
{

	/**
	 * @generated
	 */
	private final int		reorientDirection;

	/**
	 * @generated
	 */
	private final EObject	oldEnd;

	/**
	 * @generated
	 */
	private final EObject	newEnd;

	/**
	 * @generated
	 */
	public MapEntryLinkReorientCommand(ReorientRelationshipRequest request)
	{
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute()
	{
		if (false == getElementToEdit() instanceof MapEntryLink)
		{
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE)
		{
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET)
		{
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource()
	{
		if (!(oldEnd instanceof AbstractStoryPatternObject && newEnd instanceof AbstractStoryPatternObject))
		{
			return false;
		}
		AbstractStoryPatternObject target = getLink().getTarget();
		if (!(getLink().eContainer() instanceof StoryPattern))
		{
			return false;
		}
		StoryPattern container = (StoryPattern) getLink().eContainer();
		return MlsdmBaseItemSemanticEditPolicy.getLinkConstraints().canExistMapEntryLink_4006(container, getLink(), getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget()
	{
		if (!(oldEnd instanceof AbstractStoryPatternObject && newEnd instanceof AbstractStoryPatternObject))
		{
			return false;
		}
		AbstractStoryPatternObject source = getLink().getSource();
		if (!(getLink().eContainer() instanceof StoryPattern))
		{
			return false;
		}
		StoryPattern container = (StoryPattern) getLink().eContainer();
		return MlsdmBaseItemSemanticEditPolicy.getLinkConstraints().canExistMapEntryLink_4006(container, getLink(), source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
	{
		if (!canExecute())
		{
			throw new ExecutionException("Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE)
		{
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET)
		{
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException
	{
		getLink().setSource(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException
	{
		getLink().setTarget(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected MapEntryLink getLink()
	{
		return (MapEntryLink) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getOldSource()
	{
		return (AbstractStoryPatternObject) oldEnd;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getNewSource()
	{
		return (AbstractStoryPatternObject) newEnd;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getOldTarget()
	{
		return (AbstractStoryPatternObject) oldEnd;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getNewTarget()
	{
		return (AbstractStoryPatternObject) newEnd;
	}
}
