package de.mdelab.mlsdm.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;

/**
 * @generated
 */
public class MlsdmEditPartFactory implements EditPartFactory
{

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model)
	{
		if (model instanceof View)
		{
			View view = (View) model;
			switch (MlsdmVisualIDRegistry.getVisualID(view))
			{

				case ActivityEditPart.VISUAL_ID:
					return new ActivityEditPart(view);

				case ActivityFinalNodeEditPart.VISUAL_ID:
					return new ActivityFinalNodeEditPart(view);

				case WrappingLabelEditPart.VISUAL_ID:
					return new WrappingLabelEditPart(view);

				case DecisionMergeNodeEditPart.VISUAL_ID:
					return new DecisionMergeNodeEditPart(view);

				case ExpressionActivityNodeEditPart.VISUAL_ID:
					return new ExpressionActivityNodeEditPart(view);

				case ExpressionActivityNodeNameEditPart.VISUAL_ID:
					return new ExpressionActivityNodeNameEditPart(view);

				case FlowFinalNodeEditPart.VISUAL_ID:
					return new FlowFinalNodeEditPart(view);

				case ForkJoinNodeEditPart.VISUAL_ID:
					return new ForkJoinNodeEditPart(view);

				case InitialNodeEditPart.VISUAL_ID:
					return new InitialNodeEditPart(view);

				case WrappingLabel2EditPart.VISUAL_ID:
					return new WrappingLabel2EditPart(view);

				case StoryNodeEditPart.VISUAL_ID:
					return new StoryNodeEditPart(view);

				case StoryNodeNameEditPart.VISUAL_ID:
					return new StoryNodeNameEditPart(view);

				case StructuredNodeEditPart.VISUAL_ID:
					return new StructuredNodeEditPart(view);

				case MLStringExpressionEditPart.VISUAL_ID:
					return new MLStringExpressionEditPart(view);

				case CallActionExpression2EditPart.VISUAL_ID:
					return new CallActionExpression2EditPart(view);

				case StoryPatternEditPart.VISUAL_ID:
					return new StoryPatternEditPart(view);

				case StoryPatternObjectEditPart.VISUAL_ID:
					return new StoryPatternObjectEditPart(view);

				case StoryPatternObjectNameEditPart.VISUAL_ID:
					return new StoryPatternObjectNameEditPart(view);

				case WrappingLabel5EditPart.VISUAL_ID:
					return new WrappingLabel5EditPart(view);

				case WrappingLabel6EditPart.VISUAL_ID:
					return new WrappingLabel6EditPart(view);

				case MLStringExpression2EditPart.VISUAL_ID:
					return new MLStringExpression2EditPart(view);

				case AttributeAssignmentEditPart.VISUAL_ID:
					return new AttributeAssignmentEditPart(view);

				case CallActionExpressionEditPart.VISUAL_ID:
					return new CallActionExpressionEditPart(view);

				case MLStringExpression3EditPart.VISUAL_ID:
					return new MLStringExpression3EditPart(view);

				case CallActionExpression3EditPart.VISUAL_ID:
					return new CallActionExpression3EditPart(view);

				case StoryPattern2EditPart.VISUAL_ID:
					return new StoryPattern2EditPart(view);

				case StoryPatternName2EditPart.VISUAL_ID:
					return new StoryPatternName2EditPart(view);

				case DecisionMergeNode2EditPart.VISUAL_ID:
					return new DecisionMergeNode2EditPart(view);

				case ExpressionActivityNode2EditPart.VISUAL_ID:
					return new ExpressionActivityNode2EditPart(view);

				case ExpressionActivityNodeName2EditPart.VISUAL_ID:
					return new ExpressionActivityNodeName2EditPart(view);

				case FlowFinalNode2EditPart.VISUAL_ID:
					return new FlowFinalNode2EditPart(view);

				case ForkJoinNode2EditPart.VISUAL_ID:
					return new ForkJoinNode2EditPart(view);

				case InitialNode2EditPart.VISUAL_ID:
					return new InitialNode2EditPart(view);

				case WrappingLabel13EditPart.VISUAL_ID:
					return new WrappingLabel13EditPart(view);

				case StoryNode2EditPart.VISUAL_ID:
					return new StoryNode2EditPart(view);

				case StoryNodeName2EditPart.VISUAL_ID:
					return new StoryNodeName2EditPart(view);

				case StructuredNode2EditPart.VISUAL_ID:
					return new StructuredNode2EditPart(view);

				case ActivityFinalNode2EditPart.VISUAL_ID:
					return new ActivityFinalNode2EditPart(view);

				case WrappingLabel3EditPart.VISUAL_ID:
					return new WrappingLabel3EditPart(view);

				case ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID:
					return new ExpressionActivityNodeExpressionFigureCompartmentEditPart(view);

				case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
					return new StoryNodeStoryNodeElementsCompartmentEditPart(view);

				case StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID:
					return new StoryPatternStoryPatternElementsCompartmentEditPart(view);

				case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
					return new StoryPatternStoryPatternConstraintsCompartmentEditPart(view);

				case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
					return new StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart(view);

				case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
					return new StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart(view);

				case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
					return new StoryPatternStoryPatternElementsCompartment2EditPart(view);

				case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
					return new StoryPatternStoryPatternConstraintsCompartment2EditPart(view);

				case ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID:
					return new ExpressionActivityNodeExpressionFigureCompartment2EditPart(view);

				case StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID:
					return new StoryNodeStoryNodeElementsCompartment2EditPart(view);

				case ActivityEdgeEditPart.VISUAL_ID:
					return new ActivityEdgeEditPart(view);

				case WrappingLabel4EditPart.VISUAL_ID:
					return new WrappingLabel4EditPart(view);

				case StoryPatternLinkEditPart.VISUAL_ID:
					return new StoryPatternLinkEditPart(view);

				case WrappingLabel7EditPart.VISUAL_ID:
					return new WrappingLabel7EditPart(view);

				case WrappingLabel8EditPart.VISUAL_ID:
					return new WrappingLabel8EditPart(view);

				case ContainmentLinkEditPart.VISUAL_ID:
					return new ContainmentLinkEditPart(view);

				case ExpressionLinkEditPart.VISUAL_ID:
					return new ExpressionLinkEditPart(view);

				case WrappingLabel9EditPart.VISUAL_ID:
					return new WrappingLabel9EditPart(view);

				case LinkOrderConstraintEditPart.VISUAL_ID:
					return new LinkOrderConstraintEditPart(view);

				case WrappingLabel15EditPart.VISUAL_ID:
					return new WrappingLabel15EditPart(view);

				case MapEntryLinkEditPart.VISUAL_ID:
					return new MapEntryLinkEditPart(view);

				case WrappingLabel10EditPart.VISUAL_ID:
					return new WrappingLabel10EditPart(view);

				case WrappingLabel11EditPart.VISUAL_ID:
					return new WrappingLabel11EditPart(view);

				case MapEntryLinkValueTargetEditPart.VISUAL_ID:
					return new MapEntryLinkValueTargetEditPart(view);

				case WrappingLabel12EditPart.VISUAL_ID:
					return new WrappingLabel12EditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model)
	{
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(ITextAwareEditPart source)
	{
		return CellEditorLocatorAccess.INSTANCE.getTextCellEditorLocator(source);
	}

}
