package de.mdelab.mlsdm.diagram.edit.parts;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.edit.policies.reparent.CreationEditPolicyWithCustomReparent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import de.mdelab.mlsdm.diagram.edit.policies.StoryPattern2ItemSemanticEditPolicy;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class StoryPattern2EditPart extends ShapeNodeEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 3017;

	/**
	 * @generated
	 */
	protected IFigure		contentPane;

	/**
	 * @generated
	 */
	protected IFigure		primaryShape;

	/**
	 * @generated
	 */
	public StoryPattern2EditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		installEditPolicy(EditPolicyRoles.CREATION_ROLE, new CreationEditPolicyWithCustomReparent(MlsdmVisualIDRegistry.TYPED_INSTANCE));
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new StoryPattern2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy()
	{
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy()
		{

			protected EditPolicy createChildEditPolicy(EditPart child)
			{
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null)
				{
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request)
			{
				return null;
			}

			protected Command getCreateCommand(CreateRequest request)
			{
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape()
	{
		return primaryShape = new NegativeStoryPatternDescriptor();
	}

	/**
	 * @generated
	 */
	public NegativeStoryPatternDescriptor getPrimaryShape()
	{
		return (NegativeStoryPatternDescriptor) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof StoryPatternName2EditPart)
		{
			((StoryPatternName2EditPart) childEditPart).setLabel(getPrimaryShape().getFigureNegativeStoryPatternName());
			return true;
		}
		if (childEditPart instanceof StoryPatternStoryPatternElementsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureNegativeStoryPatternElementsRectangle();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((StoryPatternStoryPatternElementsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof StoryPatternStoryPatternConstraintsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureNegativeStoryPatternFigureTitleRectangle();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((StoryPatternStoryPatternConstraintsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof StoryPatternName2EditPart)
		{
			return true;
		}
		if (childEditPart instanceof StoryPatternStoryPatternElementsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureNegativeStoryPatternElementsRectangle();
			pane.remove(((StoryPatternStoryPatternElementsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof StoryPatternStoryPatternConstraintsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureNegativeStoryPatternFigureTitleRectangle();
			pane.remove(((StoryPatternStoryPatternConstraintsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index)
	{
		if (addFixedChild(childEditPart))
		{
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart)
	{
		if (removeFixedChild(childEditPart))
		{
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart)
	{
		if (editPart instanceof StoryPatternStoryPatternElementsCompartment2EditPart)
		{
			return getPrimaryShape().getFigureNegativeStoryPatternElementsRectangle();
		}
		if (editPart instanceof StoryPatternStoryPatternConstraintsCompartment2EditPart)
		{
			return getPrimaryShape().getFigureNegativeStoryPatternFigureTitleRectangle();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate()
	{
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated NOT
	 */
	protected NodeFigure createNodeFigure()
	{
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new ResizableFlowLayout());
		//figure.setLayoutManager(new ResizableFlowLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape)
	{
		if (nodeShape.getLayoutManager() == null)
		{
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane()
	{
		if (contentPane != null)
		{
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart()
	{
		return getChildBySemanticHint(MlsdmVisualIDRegistry.getType(StoryPatternName2EditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request)
	{
		if (request instanceof CreateViewAndElementRequest)
		{
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request).getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter.getAdapter(IElementType.class);
			if (type == MlsdmElementTypes.MLStringExpression_3014)
			{
				return getChildBySemanticHint(MlsdmVisualIDRegistry
						.getType(StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID));
			}
			if (type == MlsdmElementTypes.CallActionExpression_3015)
			{
				return getChildBySemanticHint(MlsdmVisualIDRegistry
						.getType(StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class NegativeStoryPatternDescriptor extends RoundedRectangle
	{

		/**
		 * @generated
		 */
		private RoundedRectangle	fFigureNegativeStoryPatternFigureTitleRectangle;
		/**
		 * @generated
		 */
		private WrappingLabel		fFigureNegativeStoryPatternName;
		/**
		 * @generated
		 */
		private RoundedRectangle	fFigureNegativeStoryPatternElementsRectangle;

		/**
		 * @generated
		 */
		public NegativeStoryPatternDescriptor()
		{

			BorderLayout layoutThis = new BorderLayout();
			this.setLayoutManager(layoutThis);

			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			this.setOutline(false);
			this.setForegroundColor(ColorConstants.black);
			this.setBackgroundColor(THIS_BACK);
			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(50)));
			this.setBorder(new LineBorder(null, getMapMode().DPtoLP(1)));
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents()
		{

			RoundedRectangle upperPart0 = new RoundedRectangle();

			upperPart0.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			upperPart0.setOutline(false);
			upperPart0.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(45)));

			this.add(upperPart0, BorderLayout.TOP);

			BorderLayout layoutUpperPart0 = new BorderLayout();
			upperPart0.setLayoutManager(layoutUpperPart0);

			RoundedRectangle negativeStoryPatternTitle1 = new RoundedRectangle();

			negativeStoryPatternTitle1.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			negativeStoryPatternTitle1.setOutline(false);
			negativeStoryPatternTitle1.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(30)));

			upperPart0.add(negativeStoryPatternTitle1, BorderLayout.TOP);

			GridLayout layoutNegativeStoryPatternTitle1 = new GridLayout();
			layoutNegativeStoryPatternTitle1.numColumns = 1;
			layoutNegativeStoryPatternTitle1.makeColumnsEqualWidth = true;
			negativeStoryPatternTitle1.setLayoutManager(layoutNegativeStoryPatternTitle1);

			fFigureNegativeStoryPatternName = new WrappingLabel();

			fFigureNegativeStoryPatternName.setText("");

			fFigureNegativeStoryPatternName.setFont(FFIGURENEGATIVESTORYPATTERNNAME_FONT);

			GridData constraintFFigureNegativeStoryPatternName = new GridData();
			constraintFFigureNegativeStoryPatternName.verticalAlignment = GridData.CENTER;
			constraintFFigureNegativeStoryPatternName.horizontalAlignment = GridData.CENTER;
			constraintFFigureNegativeStoryPatternName.horizontalIndent = 0;
			constraintFFigureNegativeStoryPatternName.horizontalSpan = 1;
			constraintFFigureNegativeStoryPatternName.verticalSpan = 1;
			constraintFFigureNegativeStoryPatternName.grabExcessHorizontalSpace = true;
			constraintFFigureNegativeStoryPatternName.grabExcessVerticalSpace = false;
			negativeStoryPatternTitle1.add(fFigureNegativeStoryPatternName, constraintFFigureNegativeStoryPatternName);

			fFigureNegativeStoryPatternFigureTitleRectangle = new RoundedRectangle();

			fFigureNegativeStoryPatternFigureTitleRectangle.setCornerDimensions(new Dimension(getMapMode().DPtoLP(7), getMapMode()
					.DPtoLP(7)));
			fFigureNegativeStoryPatternFigureTitleRectangle.setOutline(false);
			fFigureNegativeStoryPatternFigureTitleRectangle.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode()
					.DPtoLP(15)));
			fFigureNegativeStoryPatternFigureTitleRectangle
					.setMaximumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(30)));

			upperPart0.add(fFigureNegativeStoryPatternFigureTitleRectangle, BorderLayout.CENTER);
			fFigureNegativeStoryPatternFigureTitleRectangle.setLayoutManager(new StackLayout());

			RoundedRectangle negativeStoryNodeContentRectangle0 = new RoundedRectangle();

			negativeStoryNodeContentRectangle0.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			negativeStoryNodeContentRectangle0.setOutline(false);
			negativeStoryNodeContentRectangle0.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(100)));

			this.add(negativeStoryNodeContentRectangle0, BorderLayout.CENTER);

			BorderLayout layoutNegativeStoryNodeContentRectangle0 = new BorderLayout();
			negativeStoryNodeContentRectangle0.setLayoutManager(layoutNegativeStoryNodeContentRectangle0);

			fFigureNegativeStoryPatternElementsRectangle = new RoundedRectangle();

			fFigureNegativeStoryPatternElementsRectangle.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			fFigureNegativeStoryPatternElementsRectangle.setOutline(false);

			negativeStoryNodeContentRectangle0.add(fFigureNegativeStoryPatternElementsRectangle, BorderLayout.CENTER);
			fFigureNegativeStoryPatternElementsRectangle.setLayoutManager(new StackLayout());

		}

		/**
		 * @generated
		 */
		public RoundedRectangle getFigureNegativeStoryPatternFigureTitleRectangle()
		{
			return fFigureNegativeStoryPatternFigureTitleRectangle;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureNegativeStoryPatternName()
		{
			return fFigureNegativeStoryPatternName;
		}

		/**
		 * @generated
		 */
		public RoundedRectangle getFigureNegativeStoryPatternElementsRectangle()
		{
			return fFigureNegativeStoryPatternElementsRectangle;
		}

	}

	/**
	 * @generated
	 */
	static final Color	THIS_BACK								= new Color(null, 252, 254, 204);

	/**
	 * @generated
	 */
	static final Font	FFIGURENEGATIVESTORYPATTERNNAME_FONT	= new Font(Display.getCurrent(), Display.getDefault().getSystemFont()
																		.getFontData()[0].getName(), 10, SWT.BOLD);

}
