package de.mdelab.mlsdm.diagram.edit.policies;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.core.util.ViewUtil;
import org.eclipse.gmf.runtime.diagram.ui.commands.DeferredLayoutCommand;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.commands.SetViewMutabilityCommand;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CanonicalEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateConnectionViewRequest;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewRequest;
import org.eclipse.gmf.runtime.diagram.ui.requests.RequestConstants;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramUpdater;
import de.mdelab.mlsdm.diagram.part.MlsdmLinkDescriptor;
import de.mdelab.mlsdm.diagram.part.MlsdmNodeDescriptor;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;

/**
 * @generated
 */
public class ActivityCanonicalEditPolicy extends CanonicalEditPolicy
{

	/**
	 * @generated
	 */
	protected void refreshOnActivate()
	{
		// Need to activate editpart children before invoking the canonical refresh for EditParts to add event listeners
		List<?> c = getHost().getChildren();
		for (int i = 0; i < c.size(); i++)
		{
			((EditPart) c.get(i)).activate();
		}
		super.refreshOnActivate();
	}

	/**
	 * @generated
	 */
	protected EStructuralFeature getFeatureToSynchronize()
	{
		return MlsdmPackage.eINSTANCE.getActivityNodeContainer_Nodes();
	}

	/**
	 * @generated
	 */
	@SuppressWarnings("rawtypes")
	protected List getSemanticChildrenList()
	{
		View viewObject = (View) getHost().getModel();
		LinkedList<EObject> result = new LinkedList<EObject>();
		List<MlsdmNodeDescriptor> childDescriptors = MlsdmDiagramUpdater.getActivity_1000SemanticChildren(viewObject);
		for (MlsdmNodeDescriptor d : childDescriptors)
		{
			result.add(d.getModelElement());
		}
		return result;
	}

	/**
	 * @generated
	 */
	protected boolean isOrphaned(Collection<EObject> semanticChildren, final View view)
	{
		return isMyDiagramElement(view) && !semanticChildren.contains(view.getElement());
	}

	/**
	 * @generated
	 */
	private boolean isMyDiagramElement(View view)
	{
		int visualID = MlsdmVisualIDRegistry.getVisualID(view);
		switch (visualID)
		{
			case ActivityFinalNodeEditPart.VISUAL_ID:
			case DecisionMergeNodeEditPart.VISUAL_ID:
			case ExpressionActivityNodeEditPart.VISUAL_ID:
			case FlowFinalNodeEditPart.VISUAL_ID:
			case ForkJoinNodeEditPart.VISUAL_ID:
			case InitialNodeEditPart.VISUAL_ID:
			case StoryNodeEditPart.VISUAL_ID:
			case StructuredNodeEditPart.VISUAL_ID:
				return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void refreshSemantic()
	{
		if (resolveSemanticElement() == null)
		{
			return;
		}
		LinkedList<IAdaptable> createdViews = new LinkedList<IAdaptable>();
		List<MlsdmNodeDescriptor> childDescriptors = MlsdmDiagramUpdater.getActivity_1000SemanticChildren((View) getHost().getModel());
		LinkedList<View> orphaned = new LinkedList<View>();
		// we care to check only views we recognize as ours
		LinkedList<View> knownViewChildren = new LinkedList<View>();
		for (View v : getViewChildren())
		{
			if (isMyDiagramElement(v))
			{
				knownViewChildren.add(v);
			}
		}
		// alternative to #cleanCanonicalSemanticChildren(getViewChildren(), semanticChildren)
		//
		// iteration happens over list of desired semantic elements, trying to find best matching View, while original CEP
		// iterates views, potentially losing view (size/bounds) information - i.e. if there are few views to reference same EObject, only last one 
		// to answer isOrphaned == true will be used for the domain element representation, see #cleanCanonicalSemanticChildren()
		for (Iterator<MlsdmNodeDescriptor> descriptorsIterator = childDescriptors.iterator(); descriptorsIterator.hasNext();)
		{
			MlsdmNodeDescriptor next = descriptorsIterator.next();
			String hint = MlsdmVisualIDRegistry.getType(next.getVisualID());
			LinkedList<View> perfectMatch = new LinkedList<View>(); // both semanticElement and hint match that of NodeDescriptor
			for (View childView : getViewChildren())
			{
				EObject semanticElement = childView.getElement();
				if (next.getModelElement().equals(semanticElement))
				{
					if (hint.equals(childView.getType()))
					{
						perfectMatch.add(childView);
						// actually, can stop iteration over view children here, but
						// may want to use not the first view but last one as a 'real' match (the way original CEP does
						// with its trick with viewToSemanticMap inside #cleanCanonicalSemanticChildren
					}
				}
			}
			if (perfectMatch.size() > 0)
			{
				descriptorsIterator.remove(); // precise match found no need to create anything for the NodeDescriptor
				// use only one view (first or last?), keep rest as orphaned for further consideration
				knownViewChildren.remove(perfectMatch.getFirst());
			}
		}
		// those left in knownViewChildren are subject to removal - they are our diagram elements we didn't find match to,
		// or those we have potential matches to, and thus need to be recreated, preserving size/location information.
		orphaned.addAll(knownViewChildren);
		//
		ArrayList<CreateViewRequest.ViewDescriptor> viewDescriptors = new ArrayList<CreateViewRequest.ViewDescriptor>(
				childDescriptors.size());
		for (MlsdmNodeDescriptor next : childDescriptors)
		{
			String hint = MlsdmVisualIDRegistry.getType(next.getVisualID());
			IAdaptable elementAdapter = new CanonicalElementAdapter(next.getModelElement(), hint);
			CreateViewRequest.ViewDescriptor descriptor = new CreateViewRequest.ViewDescriptor(elementAdapter, Node.class, hint,
					ViewUtil.APPEND, false, host().getDiagramPreferencesHint());
			viewDescriptors.add(descriptor);
		}

		boolean changed = deleteViews(orphaned.iterator());
		//
		CreateViewRequest request = getCreateViewRequest(viewDescriptors);
		Command cmd = getCreateViewCommand(request);
		if (cmd != null && cmd.canExecute())
		{
			SetViewMutabilityCommand.makeMutable(new EObjectAdapter(host().getNotationView())).execute();
			executeCommand(cmd);
			@SuppressWarnings("unchecked")
			List<IAdaptable> nl = (List<IAdaptable>) request.getNewObject();
			createdViews.addAll(nl);
		}
		if (changed || createdViews.size() > 0)
		{
			postProcessRefreshSemantic(createdViews);
		}

		Collection<IAdaptable> createdConnectionViews = refreshConnections();

		if (createdViews.size() > 1)
		{
			// perform a layout of the container
			DeferredLayoutCommand layoutCmd = new DeferredLayoutCommand(host().getEditingDomain(), createdViews, host());
			executeCommand(new ICommandProxy(layoutCmd));
		}

		createdViews.addAll(createdConnectionViews);

		makeViewsImmutable(createdViews);
	}

	/**
	 * @generated
	 */
	private Collection<IAdaptable> refreshConnections()
	{
		Map<EObject, View> domain2NotationMap = new HashMap<EObject, View>();
		Collection<MlsdmLinkDescriptor> linkDescriptors = collectAllLinks(getDiagram(), domain2NotationMap);
		Collection existingLinks = new LinkedList(getDiagram().getEdges());
		for (Iterator linksIterator = existingLinks.iterator(); linksIterator.hasNext();)
		{
			Edge nextDiagramLink = (Edge) linksIterator.next();
			int diagramLinkVisualID = MlsdmVisualIDRegistry.getVisualID(nextDiagramLink);
			if (diagramLinkVisualID == -1)
			{
				if (nextDiagramLink.getSource() != null && nextDiagramLink.getTarget() != null)
				{
					linksIterator.remove();
				}
				continue;
			}
			EObject diagramLinkObject = nextDiagramLink.getElement();
			EObject diagramLinkSrc = nextDiagramLink.getSource().getElement();
			EObject diagramLinkDst = nextDiagramLink.getTarget().getElement();
			for (Iterator<MlsdmLinkDescriptor> linkDescriptorsIterator = linkDescriptors.iterator(); linkDescriptorsIterator.hasNext();)
			{
				MlsdmLinkDescriptor nextLinkDescriptor = linkDescriptorsIterator.next();
				if (diagramLinkObject == nextLinkDescriptor.getModelElement() && diagramLinkSrc == nextLinkDescriptor.getSource()
						&& diagramLinkDst == nextLinkDescriptor.getDestination() && diagramLinkVisualID == nextLinkDescriptor.getVisualID())
				{
					linksIterator.remove();
					linkDescriptorsIterator.remove();
					break;
				}
			}
		}
		deleteViews(existingLinks.iterator());
		return createConnections(linkDescriptors, domain2NotationMap);
	}

	/**
	 * @generated
	 */
	private Collection<MlsdmLinkDescriptor> collectAllLinks(View view, Map<EObject, View> domain2NotationMap)
	{
		if (!ActivityEditPart.MODEL_ID.equals(MlsdmVisualIDRegistry.getModelID(view)))
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		switch (MlsdmVisualIDRegistry.getVisualID(view))
		{
			case ActivityEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getActivity_1000ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ActivityFinalNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getActivityFinalNode_2002ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case DecisionMergeNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getDecisionMergeNode_2006ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ExpressionActivityNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getExpressionActivityNode_2001ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case FlowFinalNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getFlowFinalNode_2007ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ForkJoinNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getForkJoinNode_2003ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case InitialNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getInitialNode_2004ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryNode_2008ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StructuredNodeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStructuredNode_2009ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryPatternEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryPattern_3002ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryPatternObjectEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryPatternObject_3003ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryPattern2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryPattern_3017ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case DecisionMergeNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getDecisionMergeNode_3006ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ExpressionActivityNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getExpressionActivityNode_3007ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case FlowFinalNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getFlowFinalNode_3008ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ForkJoinNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getForkJoinNode_3009ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case InitialNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getInitialNode_3010ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryNode_3011ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StructuredNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStructuredNode_3018ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ActivityFinalNode2EditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getActivityFinalNode_3019ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ActivityEdgeEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getActivityEdge_4001ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case StoryPatternLinkEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getStoryPatternLink_4002ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ContainmentLinkEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getContainmentLink_4003ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case ExpressionLinkEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getExpressionLink_4004ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case LinkOrderConstraintEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getLinkOrderConstraint_4005ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
			case MapEntryLinkEditPart.VISUAL_ID:
			{
				if (!domain2NotationMap.containsKey(view.getElement()))
				{
					result.addAll(MlsdmDiagramUpdater.getMapEntryLink_4006ContainedLinks(view));
				}
				if (!domain2NotationMap.containsKey(view.getElement()) || view.getEAnnotation("Shortcut") == null) { //$NON-NLS-1$
					domain2NotationMap.put(view.getElement(), view);
				}
				break;
			}
		}
		for (Iterator children = view.getChildren().iterator(); children.hasNext();)
		{
			result.addAll(collectAllLinks((View) children.next(), domain2NotationMap));
		}
		for (Iterator edges = view.getSourceEdges().iterator(); edges.hasNext();)
		{
			result.addAll(collectAllLinks((View) edges.next(), domain2NotationMap));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<IAdaptable> createConnections(Collection<MlsdmLinkDescriptor> linkDescriptors, Map<EObject, View> domain2NotationMap)
	{
		LinkedList<IAdaptable> adapters = new LinkedList<IAdaptable>();
		for (MlsdmLinkDescriptor nextLinkDescriptor : linkDescriptors)
		{
			EditPart sourceEditPart = getEditPart(nextLinkDescriptor.getSource(), domain2NotationMap);
			EditPart targetEditPart = getEditPart(nextLinkDescriptor.getDestination(), domain2NotationMap);
			if (sourceEditPart == null || targetEditPart == null)
			{
				continue;
			}
			CreateConnectionViewRequest.ConnectionViewDescriptor descriptor = new CreateConnectionViewRequest.ConnectionViewDescriptor(
					nextLinkDescriptor.getSemanticAdapter(), MlsdmVisualIDRegistry.getType(nextLinkDescriptor.getVisualID()),
					ViewUtil.APPEND, false, ((IGraphicalEditPart) getHost()).getDiagramPreferencesHint());
			CreateConnectionViewRequest ccr = new CreateConnectionViewRequest(descriptor);
			ccr.setType(RequestConstants.REQ_CONNECTION_START);
			ccr.setSourceEditPart(sourceEditPart);
			sourceEditPart.getCommand(ccr);
			ccr.setTargetEditPart(targetEditPart);
			ccr.setType(RequestConstants.REQ_CONNECTION_END);
			Command cmd = targetEditPart.getCommand(ccr);
			if (cmd != null && cmd.canExecute())
			{
				executeCommand(cmd);
				IAdaptable viewAdapter = (IAdaptable) ccr.getNewObject();
				if (viewAdapter != null)
				{
					adapters.add(viewAdapter);
				}
			}
		}
		return adapters;
	}

	/**
	 * @generated
	 */
	private EditPart getEditPart(EObject domainModelElement, Map<EObject, View> domain2NotationMap)
	{
		View view = (View) domain2NotationMap.get(domainModelElement);
		if (view != null)
		{
			return (EditPart) getHost().getViewer().getEditPartRegistry().get(view);
		}
		return null;
	}

	/**
	 * @generated
	 */
	private Diagram getDiagram()
	{
		return ((View) getHost().getModel()).getDiagram();
	}
}
