package de.mdelab.mlsdm.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import de.mdelab.mlsdm.diagram.edit.commands.ActivityFinalNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.DecisionMergeNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.ExpressionActivityNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.FlowFinalNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.ForkJoinNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.InitialNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.StoryNodeCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.StructuredNodeCreateCommand;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class ActivityItemSemanticEditPolicy extends MlsdmBaseItemSemanticEditPolicy
{

	/**
	 * @generated
	 */
	public ActivityItemSemanticEditPolicy()
	{
		super(MlsdmElementTypes.Activity_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req)
	{
		if (MlsdmElementTypes.ActivityFinalNode_2002 == req.getElementType())
		{
			return getGEFWrapper(new ActivityFinalNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.DecisionMergeNode_2006 == req.getElementType())
		{
			return getGEFWrapper(new DecisionMergeNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.ExpressionActivityNode_2001 == req.getElementType())
		{
			return getGEFWrapper(new ExpressionActivityNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.FlowFinalNode_2007 == req.getElementType())
		{
			return getGEFWrapper(new FlowFinalNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.ForkJoinNode_2003 == req.getElementType())
		{
			return getGEFWrapper(new ForkJoinNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.InitialNode_2004 == req.getElementType())
		{
			return getGEFWrapper(new InitialNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.StoryNode_2008 == req.getElementType())
		{
			return getGEFWrapper(new StoryNodeCreateCommand(req));
		}
		if (MlsdmElementTypes.StructuredNode_2009 == req.getElementType())
		{
			return getGEFWrapper(new StructuredNodeCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req)
	{
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost()).getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends DuplicateEObjectsCommand
	{

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(TransactionalEditingDomain editingDomain, DuplicateElementsRequest req)
		{
			super(editingDomain, req.getLabel(), req.getElementsToBeDuplicated(), req.getAllDuplicatedElementsMap());
		}

	}

}
